package nl.kallestruik.dtweaks.managers

import org.bukkit.configuration.InvalidConfigurationException
import org.bukkit.configuration.file.YamlConfiguration
import java.io.File
import java.io.IOException
import java.util.*

class TrampleManager {
    var trampleEnabled = HashSet<UUID>()

    @Throws(IOException::class, InvalidConfigurationException::class)
    fun loadFromFile(file: File) {
        file.parentFile.mkdirs()
        file.createNewFile()
        val config = YamlConfiguration()
        config.load(file)
        for (item in config.getStringList("enabled"))
            trampleEnabled.add(UUID.fromString(item))
    }

    @Throws(IOException::class, InvalidConfigurationException::class)
    fun saveToFile(file: File) {
        file.parentFile.mkdirs()
        file.createNewFile()
        val config = YamlConfiguration()
        config.load(file)
        val list: MutableList<String> = ArrayList()
        for (entry in trampleEnabled)
            list.add(entry.toString())

        config["enabled"] = list
        config.save(file)
    }

}