package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class CraftableDragonsBreath(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "dragon_breath")

    override fun getIdentifier(): String = "CraftableDragonsBreath"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val dragonBreathRecipe = ShapedRecipe(recipeKey, ItemStack(Material.DRAGON_BREATH, 3))
        dragonBreathRecipe.shape("GCG", " G ")
        dragonBreathRecipe.setIngredient('G', Material.GLASS)
        dragonBreathRecipe.setIngredient('C', Material.POPPED_CHORUS_FRUIT)

        plugin.server.addRecipe(dragonBreathRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}