package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.plugin.java.JavaPlugin

class CraftableShulkerShell(
    private val plugin: JavaPlugin
): ITweak {
    private var recipeKey = NamespacedKey(plugin, "shulker_shell")

    override fun getIdentifier(): String = "CraftableShulkerShell"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val shulkerShellRecipe = ShapedRecipe(recipeKey, ItemStack(Material.SHULKER_SHELL))
        shulkerShellRecipe.shape("BBB", "F F")
        shulkerShellRecipe.setIngredient('B', Material.PURPUR_SLAB)
        shulkerShellRecipe.setIngredient('F', Material.POPPED_CHORUS_FRUIT)

        plugin.server.addRecipe(shulkerShellRecipe)
    }

    override fun onDisable() {
        plugin.server.removeRecipe(recipeKey)
    }
}