package nl.kallestruik.dtweaks.tweaks.craftingtweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.Bukkit
import org.bukkit.Material
import org.bukkit.NamespacedKey
import org.bukkit.Tag
import org.bukkit.inventory.ItemStack
import org.bukkit.inventory.RecipeChoice
import org.bukkit.inventory.ShapedRecipe
import org.bukkit.inventory.ShapelessRecipe
import org.bukkit.plugin.java.JavaPlugin

class MoreSandstone(
    private val plugin: JavaPlugin
): ITweak {
    private var normalRecipeKey = NamespacedKey(plugin, "sandstone")
    private var redRecipeKey = NamespacedKey(plugin, "red_sandstone")

    override fun getIdentifier(): String = "MoreSandstone"
    override fun getCategories(): List<String> = listOf("crafting", "survival")

    override fun onEnable() {
        val normalRecipe = ShapedRecipe(normalRecipeKey, ItemStack(Material.SANDSTONE, 4))
        normalRecipe.shape("ss", "ss")
        normalRecipe.setIngredient('s', Material.SAND)

        val redRecipe = ShapedRecipe(redRecipeKey, ItemStack(Material.RED_SANDSTONE, 4))
        redRecipe.shape("ss", "ss")
        redRecipe.setIngredient('s', Material.RED_SAND)

        plugin.server.addRecipe(normalRecipe)
        plugin.server.addRecipe(redRecipe)

    }

    override fun onDisable() {
        plugin.server.removeRecipe(normalRecipeKey)
        plugin.server.removeRecipe(redRecipeKey)
    }
}