package nl.kallestruik.dtweaks.tweaks.miscellaneoustweaks

import nl.kallestruik.dtweaks.tweaks.ITweak
import org.bukkit.entity.ArmorStand
import org.bukkit.event.EventHandler
import org.bukkit.event.HandlerList
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerInteractAtEntityEvent
import org.bukkit.inventory.EquipmentSlot
import org.bukkit.plugin.java.JavaPlugin

class ArmorStandArmorSwapping(
    private val plugin: JavaPlugin
): ITweak, Listener {
    override fun getIdentifier(): String = "ArmorStandArmorSwapping"
    override fun getCategories(): List<String> = listOf("miscellaneous", "survival")

    override fun onEnable() {
        plugin.server.pluginManager.registerEvents(this, plugin)
    }

    override fun onDisable() {
        HandlerList.unregisterAll(this)
    }

    @EventHandler
    fun onClickEntity(event: PlayerInteractAtEntityEvent) {
        if (event.player.isSneaking) {
            if (event.rightClicked is ArmorStand) {
                val armorStand = event.rightClicked as ArmorStand
                val standEquipment = armorStand.equipment
                val player = event.player
                val playerEquipment = player.equipment

                val playerHelmet = playerEquipment.helmet
                val playerChestplate = playerEquipment.chestplate
                val playerLeggings = playerEquipment.leggings
                val playerBoots = playerEquipment.boots

                player.inventory.helmet = standEquipment.helmet
                player.inventory.chestplate = standEquipment.chestplate
                player.inventory.leggings = standEquipment.leggings
                player.inventory.boots = standEquipment.boots

                armorStand.setItem(EquipmentSlot.HEAD, playerHelmet)
                armorStand.setItem(EquipmentSlot.CHEST, playerChestplate)
                armorStand.setItem(EquipmentSlot.LEGS, playerLeggings)
                armorStand.setItem(EquipmentSlot.FEET, playerBoots)

                event.isCancelled = true
            }
        }
    }
}